#import <AppKit/AppKit.h>

/*
 File:       VerifyController.h

 Contains:   Header file for the Controller of the "Verify" window

 Written by: Eric Simenel

 Created:    May 1997

 Copyright:  (c)1997 by Apple Computer, Inc., all rights reserved.

 Change History (most recent first):

 You may incorporate this sample code into your applications without
 restriction, though the sample code has been provided "AS IS" and the
 responsibility for its operation is 100% yours.  However, what you are
 not permitted to do is to redistribute the source as "DSC Sample Code"
 after having made changes. If you're going to re-distribute the source,
 we require that you make it clear in the source that the code was
 descended from Apple Sample Code, but that you've made changes.
*/

@interface VerifyController : NSObject
{
    id nbIssues;
    id nbTitles;
    id verifyView;
    id nbSelTitles;
    id inputWindow;

    NSMutableArray *array;
    short nbRows;
    
    short brand;
    short kind;
    short series;
    short state;
    short sort;
}

- (id)init;
- (void)awakeFromNib;

- (void)brandSelect:(id)sender;
- (void)kindSelect:(id)sender;
- (void)seriesSelect:(id)sender;
- (void)sortSelect:(id)sender;
- (void)stateSelect:(id)sender;

- (void)selChanged;

// NSTableDataSource interface
- (int)numberOfRowsInTableView:(NSTableView *)tableView;
- (id)tableView:(NSTableView *)tv objectValueForTableColumn:(NSTableColumn *)tableColumn row:(int)row;

// loading subprojects
- (void)newBrowser:(id)sender;
- (void)newCalendar:(id)sender;
- (void)newTitleLongevity:(id)sender;

// NSApp delegate
- (BOOL)applicationShouldTerminate:(id)sender;

@end
